# Copyright (C) 2018 Matthew L. Schwartz - all rights reserved
# Not for redistribution

trap_enzyme = 'SapI'

bases = ['a', 'c', 'g', 't', '-']

amino_acids = ['A', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'K', 'L', 'M',
                    'N', 'P', 'Q', 'R', 'S', 'T', 'V', 'W', 'Y', '*']

dict_program_control = {'1':'Sequence Entry', '2':'Select Translation Frame', '3':'Select Tag Type',
                        '4':'Set Insert Site', '5':'Select gRNA', '6':'Mutate Repair Template',
                        '7':'Review Design', '8':'Get Reagent Sequences'}

restriction_enzyme_list = \
    {'AatII': 'GACGTC', 'Acc65I': 'GGTACC', 'AccB1I': 'GGYRCC', 'AccI': 'GTMKAC', 'AccIII': 'TCCGGA',
     'AclI': 'AACGTT', 'AcyI': 'GRCGYC', 'AflII': 'CTTAAG', 'AflIII': 'ACRYGT', 'AgeI': 'ACCGGT',
     'AlwNI': 'CAGNNNCTG', 'ApaI': 'GGGCCC', 'ApaLI': 'GTGCAC', 'ApoI': 'RAATTY', 'AscI': 'GGCGCGCC',
     'AvaI': 'CYCGRG', 'AvrII': 'CCTAGG', 'BamHI': 'GGATCC', 'BanII': 'GRGCYC', 'BbeI': 'GGCGCC',
     'BclI': 'TGATCA', 'BfmI': 'CTRYAG', 'BglI': 'GCCNNNNNGGC', 'BglII': 'AGATCT', 'BlpI': 'GCTNAGC',
     'BsaAI': 'YACGTR', 'BsaBI': 'GATNNNNATC', 'BsaI': 'GGTCTC', 'BsaWI': 'WCCGGW', 'BseRI': 'GAGGAG',
     'BseSI': 'GKGCMC', 'BsiEI': 'CGRYCG', 'BsiHKAI': 'GWGCWC', 'BsiWI': 'CGTACG', 'Bsp120I': 'GGGCCC',
     'BspHI': 'TCATGA', 'BspLU11I': 'ACATGT', 'BsrGI': 'TGTACA', 'BssHII': 'GCGCGC', 'BstAPI': 'GCANNNNNTGC',
     'BstBI': 'TTCGAA', 'BstEII': 'GGTNACC', 'BstXI': 'CCANNNNNNTGG', 'BstZ17I': 'GTATAC', 'Bsu36I': 'CCTNAGG',
     'BtrI': 'CACGTC', 'Cfr10I': 'RCCGGY', 'CfrI': 'YGGCCR', 'ClaI': 'ATCGAT', 'DraI': 'TTTAAA',
     'DraII': 'RGGNCCY', 'DraIII': 'CACNNNGTG', 'DrdI': 'GACNNNNNNGTC', 'EagI': 'CGGCCG', 'Eam1105I': 'GACNNNNNGTC',
     'EarI': 'CTCTTC', 'Eco47III': 'AGCGCT', 'EcoNI': 'CCTNNNNNAGG', 'EcoRI': 'GAATTC', 'EcoRV': 'GATATC',
     'FseI': 'GGCCGGCC', 'FspAI': 'RTGCGCAY', 'FspI': 'TGCGCA', 'HaeII': 'RGCGCY', 'HincII': 'GTYRAC',
     'HindIII': 'AAGCTT', 'HpaI': 'GTTAAC', 'KasI': 'GGCGCC', 'KpnI': 'GGTACC', 'MfeI': 'CAATTG',
     'MluI': 'ACGCGT', 'MscI': 'TGGCCA', 'MslI': 'CAYNNNNRTG', 'MspA1I': 'CMGCKG', 'NaeI': 'GCCGGC',
     'NarI': 'GGCGCC',
     'NcoI': 'CCATGG', 'NdeI': 'CATATG', 'NgoMIV': 'GCCGGC', 'NheI': 'GCTAGC',
     'NotI': 'GCGGCCGC', 'NruI': 'TCGCGA', 'NsiI': 'ATGCAT', 'NspI': 'RCATGY',
     'OliI': 'CACNNNNGTG', 'PacI': 'TTAATTAA', 'PflMI': 'CCANNNNNTGG', 'PfoI': 'TCCNGGA',
     'PmeI': 'GTTTAAAC', 'PmlI': 'CACGTG', 'PpuMI': 'RGGWCCY', 'PshAI': 'GACNNNNGTC', 'PsiI': 'TTATAA',
     'PstI': 'CTGCAG', 'PvuI': 'CGATCG', 'PvuII': 'CAGCTG', 'RsrII': 'CGGWCCG', 'SacI': 'GAGCTC',
     'SacII': 'CCGCGG', 'SalI': 'GTCGAC', 'SanDI': 'GGGWCCC', 'SapI': 'GCTCTTC', 'SbfI': 'CCTGCAGG',
     'ScaI': 'AGTACT', 'SduI': 'GDGCHC', 'SexAI': 'ACCWGGT', 'SfiI': 'GGCCNNNNNGGCC', 'SfoI': 'GGCGCC',
     'SgfI': 'GCGATCGC', 'SgrAI': 'CRCCGGYG', 'SmaI': 'CCCGGG', 'SmlI': 'CTYRAG', 'SnaBI': 'TACGTA',
     'SpeI': 'ACTAGT', 'SphI': 'GCATGC', 'SrfI': 'GCCCGGGC', 'SspI': 'AATATT', 'StuI': 'AGGCCT',
     'StyI': 'CCWWGG', 'SwaI': 'ATTTAAAT', 'TatI': 'WGTACW', 'Tth111I': 'GACNNNGTC', 'VspI': 'ATTAAT',
     'XbaI': 'TCTAGA', 'XcmI': 'CCANNNNNNNNNTGG', 'XhoI': 'CTCGAG', 'XhoII': 'RGATCY', 'XmaI': 'CCCGGG',
     'XmnI': 'GAANNNNTTC', 'ZraI': 'GACGTC', }

degenerate_DNA_code = \
                      {'A': ['A'], 'C': ['C'], 'G': ['G'], 'T': ['T'],
                       'S': ['C', 'G'], 'W': ['A', 'T'],
                       'K': ['G', 'T'], 'M': ['A', 'C'], 'R': ['A', 'G'], 'Y': ['C', 'T'],
                       'B': ['C', 'G', 'T'], 'V': ['A', 'C', 'G'],
                       'D': ['A', 'G', 'T'], 'H': ['A', 'C', 'T'],
                       'N': ['A', 'C', 'G', 'T'],
                       'a': ['a'], 'c': ['c'], 'g': ['g'], 't': ['t'],
                       's': ['c', 'g'], 'w': ['a', 't'],
                       'k': ['g', 't'], 'm': ['a', 'c'], 'r': ['a', 'g'], 'y': ['c', 't'],
                       'b': ['c', 'g', 't'], 'v': ['a', 'c', 'g'],
                       'd': ['a', 'g', 't'], 'h': ['a', 'c', 't'],
                       'n': ['a', 'c', 'g', 't']
                       }
# need to give lowercase or convert all to uppercase

dict_degenerate_com =    \
                         {'A': 'T', 'C': 'G', 'G': 'C', 'T': 'A',
                          'S': 'S', 'W': 'W',
                          'K': 'M', 'M': 'K', 'R': 'Y', 'Y': 'R',
                          'B': 'V', 'V': 'B', 'D': 'H', 'H': 'D',
                          'N': 'N', '-': '-',
                           'a': 't', 'c': 'g', 'g': 'c', 't': 'a',
                           's': 's', 'w': 'w',
                           'k': 'm', 'm': 'k', 'r': 'y', 'y': 'r',
                           'b': 'v', 'v': 'b', 'd': 'h', 'h': 'd',
                           'n': 'n'
                          }

dict_DNA_com = {'A': 'T', 'C': 'G', 'G': 'C', 'T': 'A',
                     'a': 't', 'c': 'g', 'g': 'c', 't': 'a' }

dictGeneticCode = {     'TTT' : 'F', 'TTC' : 'F', 'TTA' : 'L', 'TTG' : 'L',
                        'CTT' : 'L', 'CTC' : 'L', 'CTA' : 'L', 'CTG' : 'L',
                        'ATT' : 'I', 'ATC' : 'I', 'ATA' : 'I', 'ATG' : 'M',
                        'GTT' : 'V', 'GTC' : 'V', 'GTA' : 'V', 'GTG' : 'V',
                        'TCT' : 'S', 'TCC' : 'S', 'TCA' : 'S', 'TCG' : 'S',
                        'CCT' : 'P', 'CCC' : 'P', 'CCA' : 'P', 'CCG' : 'P',
                        'ACT' : 'T', 'ACC' : 'T', 'ACA' : 'T', 'ACG' : 'T',
                        'GCT' : 'A', 'GCC' : 'A', 'GCA' : 'A', 'GCG' : 'A',
                        'TAT' : 'Y', 'TAC' : 'Y', 'TAA' : '*', 'TAG' : '*',
                        'CAT' : 'H', 'CAC' : 'H', 'CAA' : 'Q', 'CAG' : 'Q',
                        'AAT' : 'N', 'AAC' : 'N', 'AAA' : 'K', 'AAG' : 'K',
                        'GAT' : 'D', 'GAC' : 'D', 'GAA' : 'E', 'GAG' : 'E',
                        'TGT' : 'C', 'TGC' : 'C', 'TGA' : '*', 'TGG' : 'W',
                        'CGT' : 'R', 'CGC' : 'R', 'CGA' : 'R', 'CGG' : 'R',
                        'AGT' : 'S', 'AGC' : 'S', 'AGA' : 'R', 'AGG' : 'R',
                        'GGT' : 'G', 'GGC' : 'G', 'GGA' : 'G', 'GGG' : 'G',
                       }

dict_rev_genetic_code_elegans = \
                        {'A' : ['GCT', 'GCA', 'GCC', 'GCG'],
                         'C' : ['TGT', 'TGC' ],
                         'D' : ['GAT', 'GAC' ],
                         'E' : ['GAA', 'GAG' ],
                         'F' : ['TTT', 'TTC' ],
                         'G' : ['GGA', 'GGT', 'GGC', 'GGG' ],
                         'H' : ['CAT', 'CAC' ],
                         'I' : ['ATT', 'ATC', 'ATA'],
                         'K' : ['AAA', 'AAG' ],
                         'L' : ['CTT', 'TTG', 'CTC', 'CTG', 'TTA', 'CTA'],
                         'M' : ['ATG'],
                         'N' : ['AAT', 'AAC' ],
                         'P' : ['CCA', 'CCG', 'CCT', 'CCC'],
                         'Q' : ['CAA', 'CAG' ],
                         'R' : ['AGA', 'CGA', 'CGT', 'CGC', 'CGG', 'AGG' ],
                         'S' : ['TCA', 'TCT', 'TCG', 'AGT', 'TCC', 'AGC' ],
                         'T' : ['ACA', 'ACT', 'ACC', 'ACG' ],
                         'V' : ['GTT', 'GTG', 'GTC', 'GTA' ],
                         'W' : ['TGG' ],
                         'Y' : ['TAT', 'TAC' ],
                         '*' : ['TAA', 'TGA', 'TAG' ] }

test_site = 'cggcagcagtgagagcatgcggcgacgagagatttaggtgccttcgctacgagatatttccgcgccaaaacggtagccattctcatgaactcatgatttctt' \
            'aatacacagtcatttactgatattcaataattttcagGGTCGAGTTCCAATCAAAGTTCTATGGAGGGCTTGGATATGAGTTCGCTCCATTCTCATTCGAAA' \
            'AAATCCTTGCTGAAGAGCGTGAAGCTGAGGAGAATCTC/TAAgatcacctcggccacttcaaacagtgtgacatcgacgttcgacaaatctttaattattta' \
            'tttctagtagatatatacttctatttgaatattgtgtcgtgttgtgcttttttcttcttgtgtttgtgcatagagtttcccctcatcccccagccatctcct' \
            'ttctctaaaattgttccattttcctttcggtgaccagaatctgaattttcttcttctcgcatttttaaaattcat'

test_deletion = 'cggcagcagtgagagcatgcggcgacgagagatttaggtgccttcgctacgagatatttccgcgccaaaacggtagccattctcatgaactcatgatt' \
                'tcttaatacacagtcatttactgatattcaataattttcagGGT<CGAGTTCCAATCAAAGTTCTATGGAGGGCTTGGATATGAGTTCGCTCCATTCT' \
                'CATTCGAAAAAATCCTTGCTGAAGAGCGTGAAGCTGAGGAGAATCTC>TAAgatcacctcggccacttcaaacagtgtgacatcgacgttcgacaaat' \
                'ctttaattatttatttctagtagatatatacttctatttgaatattgtgtcgtgttgtgcttttttcttcttgtgtttgtgcatagagtttcccctca' \
                'tcccccagccatctcctttctctaaaattgttccattttcctttcggtgaccagaatctgaattttcttcttctcgcatttttaaaattcat'


""" 
    Guide specification string entry:
    [0] is: * = non-seed, ! = seed, / = sense cutsite, \ = antisense cutsite, PAM is listed in DNA bases
    [1] is display name of enzyme
    [2] is print mask for PAM string in display
        # will print distance between cutsite and insert site
        / and \ will print literally to display cutsite
        P will print PAM
"""

original_RE_list = \
{'AatII': 'GACGTC', 'Acc65I': 'GGTACC', 'AccI': 'GTMKAC', 'AclI': 'AACGTT',
 'AfeI': 'AGCGCT', 'AflII ': 'CTTAAG',
 'AgeI': 'ACCGGT', 'ApaI': 'GGGCCC', 'ApaLI': 'GTGCAC', 'ApoI': 'RAATTY', 'AscI': 'GGCGCGCC',
 'AseI': 'ATTAAT', 'AsiSI': 'GCGATCGC', 'AvrII': 'CCTAGG', 'BamHI': 'GGATCC', 'BclI': 'TGATCA',
 'BglII': 'AGATCT', 'Bme1580I': 'GKGCMC', 'BmtI': 'GCTAGC', 'BsaHI': 'GRCGYC', 'BsiEI': 'CGRYCG',
 'BsiWI': 'CGTACG', 'BspEI': 'TCCGGA', 'BspHI': 'TCATGA', 'BsrGI': 'TGTACA', 'BssHII': 'GCGCGC',
 'BstBI': 'TTCGAA', 'BstZ17I': 'GTATAC', 'BtgI': 'CCRYGG', 'ClaI ': 'ATCGAT', 'DraI ': 'TTTAAA',
 'EaeI': 'YGGCCR', 'EagI': 'CGGCCG', 'EcoRI': 'GAATTC', 'EcoRV': 'GATATC', 'FseI': 'GGCCGGCC',
 'FspI': 'TGCGCA', 'HaeII': 'RGCGCY', 'HincII': 'GTYRAC', 'HindIII': 'AAGCTT', 'HpaI': 'GTTAAC',
 'KasI': 'GGCGCC', 'KpnI': 'GGTACC', 'MfeI': 'CAATTG', 'MluI': 'ACGCGT', 'MscI': 'TGGCCA',
 'MspA1I': 'CMGCKG', 'NaeI': 'GCCGGC', 'NarI': 'GGCGCC', 'NcoI': 'CCATGG', 'NdeI': 'CATATG',
 'NgoMIV': 'GCCGGC', 'NheI': 'GCTAGC', 'NotI': 'GCGGCCGC', 'NruI': 'TCGCGA', 'NsiI': 'ATGCAT',
 'NspI': 'RCATGY', 'PacI': 'TTAATTAA', 'PciI': 'ACATGT', 'PmeI': 'GTTTAAAC', 'PmlI ': 'CACGTG',
 'PsiI': 'TTATAA', 'PspOMI': 'GGGCCC', 'PstI': 'CTGCAG', 'PvuI': 'CGATCG', 'PvuII': 'CAGCTG',
 'SacI': 'GAGCTC', 'SacII': 'CCGCGG', 'SalI': 'GTCGAC', 'SapI': 'GCTCTTC', 'SbfI': 'CCTGCAGG',
 'ScaI': 'AGTACT', 'SfcI': 'CTRYAG', 'SfoI': 'GGCGCC', 'SgrAI': 'CRCCGGYG', 'SmaI': 'CCCGGG',
 'SmlI': 'CTYRAG', 'SnaBI': 'TACGTA',
 'SpeI': 'ACTAGT', 'SphI': 'GCATGC', 'SspI': 'AATATT', 'StuI ': 'AGGCCT', 'SwaI': 'ATTTAAAT',
 'XbaI': 'TCTAGA', 'XhoI': 'CTCGAG', 'XmaI': 'CCCGGG'}
